<?php if (!defined('PmWiki')) exit();
/** \abcsong.php
 * \A recipe to allow ABC notation to produce playable music and words on a web page.
 *
 * A demonstration site is at http://s593332318.websitehome.co.uk/abcmedia/pmwiki/pmwiki.php?n=SongBook.SongBook
 * with full instructions on the recipe page at ABCHelp.ABCHelp, or on the demonstartion site at 
 * http://s593332318.websitehome.co.uk/abcmedia/pmwiki/pmwiki.php?n=Main.SongbookHelp
 *
 * Change notes
 * 2020-01-01 Original issue
 *
 * 2020-02-18 Update 1
 * Only raw abc code needs to be entered on page
 * Can select audio controls top or bottom of music
 * Improved printing
 *
 */
// This recipe's name and version
$RecipeInfo['abcsong']['Version'] = '2020-02-18';

$ActionSkin['print'] = 'abc-print';

## set default song group
#Others may be added in config.php
$SongGroup[] = "Songbook";

## Get the group and page name
$pagename = ResolvePageName($pagename);
$page = PageVar($pagename, '$FullName');
$group = PageVar($pagename, '$Group');
$name = PageVar($pagename, '$Name');

## Set to 1 to ignore definite and indefinite article in page lists and sorts
# Add to config.php - 
#         $ignoreArticle = 1;
if($IgnoreArticle==1) {
	$FmtPV['$FullTitle'] = $FmtPV['$Title'];
	$FmtPV['$Title'] = "preg_replace('/^(A|The|Les) /','',".$FmtPV['$Titlespaced'].")";
	}
	
if (in_array($group, $SongGroup)){
	if ($name <> $group) {
		if($action!='edit' and $action!='diff' and $action!='login') {
			## set template page
			$EditTemplatesFmt = array('Songbook.Template');
			
			$FmtPV['$PlainText'] = 'FmtPlainText($pn)';
			
			function FmtPlainText($pn) {
				$page = RetrieveAuthPage($pn, 'read', false, READPAGE_CURRENT);
				if (! @$page['text']) return '';
				return Keep(PHSC($page['text'], ENT_QUOTES));
				}
	
			if($action=='print') {
				Markup("abc", "inline", "/abc(.*?)abc/", "
				</div>
				<textarea name='abc' id='abc' cols='80' rows='15' style='display: none'>$1</textarea>
				<div id='paper0' class='paper'></div>
				<div id='paper1' class='paper'></div>
				<div id='paper2' class='paper'></div>
				<div id='paper3' class='paper'></div>
				<div id='selection'></div>;");
				} else {
				if ($Top == 0) {
					Markup("abc", "inline", "/abc(.*?)abc/", "
					</div>
					<div>
					<button onclick='ShowHide()'>Show/Hide ABC</button>
					</div>
					<textarea name='abc' id='abc' cols='80' rows='15' style='display: none'>$1</textarea>
					<hr />
					<div id='paper0' class='paper'></div>
					<div id='paper1' class='paper'></div>
					<div id='paper2' class='paper'></div>
					<div id='paper3' class='paper'></div>
					<div id='audio'></div>
					<div id='selection'></div>;");
					} else {
					Markup("abc", "inline", "/abc(.*?)abc/", "
					</div>
					<div>
					<button onclick='ShowHide()'>Show/Hide ABC</button>
					</div>
					<textarea name='abc' id='abc' cols='80' rows='15' style='display: none'>$1</textarea>
					<hr />
					<div id='audio'></div>
					<div id='paper0' class='paper'></div>
					<div id='paper1' class='paper'></div>
					<div id='paper2' class='paper'></div>
					<div id='paper3' class='paper'></div>
					<div id='selection'></div>;");
					}
				}
			
							
				$PageTextStartFmt = "<div style='display: none'>";
			
				$HTMLHeaderFmt['abc'] =
				'
				<script src="//code.jquery.com/jquery-1.10.2.js"></script>
				<link href="//maxcdn.bootstrapcdn.com/bootstrap/3.3.0/css/bootstrap.min.css" rel="stylesheet" id="bootstrap-css">
				<script src="//maxcdn.bootstrapcdn.com/bootstrap/3.3.0/js/bootstrap.min.js"></script>
				<script src="//code.jquery.com/jquery-1.11.1.min.js"></script>
				<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.5.0/css/font-awesome.min.css">
				<!-- ABC -->
				<link href="$PubDirUrl/abcjs/abcjs-audio.css" media="all" rel="stylesheet" type="text/css" />
				<script src="$PubDirUrl/abcjs/abcjs_basic_5.9.1-min.js" type="text/javascript"></script>
				<style>
					.abcjs-inline-midi {
						max-width: 740px;
					}
					@media print {
						h1, p, textarea, #selection, #midi, #midi-download, hr {
							display: none;
						}
						.paper {
							position: absolute;
						}
					}
				</style>
				<script>
				function ShowHide() {
				  var x = document.getElementById("abc");
				  if (x.style.display === "none") {
					x.style.display = "block";
				  } else {
					x.style.display = "none";
				  }
				}
				</script>';

			$HTMLFooterFmt['abc'] =
			'	<script type="text/javascript">
				function selectionCallback(abcelem) {
					var note = {};
					for (var key in abcelem) {
						if (abcelem.hasOwnProperty(key) && key !== "abselem")
							note[key] = abcelem[key];
					}
					console.log(abcelem);
					var el = document.getElementById("selection");
					el.innerHTML = "<b>selectionCallback parameter:</b><br>" + JSON.stringify(note);
				}

				function initEditor() {
					new ABCJS.Editor("abc", { paper_id: "paper0",
						synth: {
							el: "#audio",
							options: { displayLoop: true, displayRestart: true, displayPlay: true, displayProgress: true, displayWarp: true }
						},
						generate_warnings: true,
						warnings_id:"warnings",
						abcjsParams: {
							generateDownload: true,
							clickListener: selectionCallback
							}
						}
					);
				}

				window.addEventListener("load", initEditor, false);
				</script>';
		
			}
		}

	}


